﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AleMugDemo
{
    public static class DynamicDemo
    {
        public static IEnumerable<dynamic> GetSortedData(IEnumerable<dynamic> initialCollection, Func<dynamic, dynamic> sortExpression)
        {
            dynamic retVal = (from one in initialCollection
                              orderby sortExpression(one)
                              select one);
            return retVal;
        }

        public static IEnumerable<dynamic> Test(List<Person> list)
        {
            return GetSortedData(list, new Func<dynamic, dynamic>(a => a.FirstName));
        }

        public static List<Person> GetList()
        {
            List<Person> list = new List<Person>();
            for (int i = 0; i < 100000; i++)
            {
                list.Add(new Person() { FirstName = i.ToString(), LastName = i.ToString() });
            }
            return list;
        }

     
    }

    public class Person
    {
        public string FirstName { get; set; }
        public string LastName { get; set; }
    }
}
